#include <glib.h>

GMutexFunctions g_mutex_functions_for_glib_use; /* is NULLified as default */
gboolean g_mutex_supported = FALSE;
gboolean g_cond_supported = FALSE;
GMutex *g_mutex_protect_static_mutex_allocation = NULL;

GStaticMutex g_static_mutex_init(GStaticMutex* mutex)
{
  g_assert( g_mutex_supported );
  g_assert( g_mutex_protect_static_mutex_allocation );
  
  g_mutex_lock( g_mutex_protect_static_mutex_allocation );

  /* This should be atomic to prevent another thread to find the mutex
     nonzero while still being uninitialized. The other way, finding
     it zero and entering this routine to find it initialized by
     another thread is uncritical due to the mutex used here. */
  if( !(*mutex) ) *mutex = g_mutex_new(); 

  g_mutex_unlock( g_mutex_protect_static_mutex_allocation );

  return *mutex;
}

